"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("./config");
function Endpoint(method, path, extraConfig = {}) {
    return (target, key, descriptor) => {
        if (!target.constructor[config_1.FUNCTIONS_METADATA]) {
            target.constructor[config_1.FUNCTIONS_METADATA] = {};
        }
        const config = target.constructor[config_1.FUNCTIONS_METADATA][key];
        if (!config.events) {
            config.events = [];
        }
        config.events.push({
            http: Object.assign({ method, path }, extraConfig),
        });
        return descriptor;
    };
}
exports.Endpoint = Endpoint;
