"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const aws_sdk_1 = require("aws-sdk");
const config_1 = require("./config");
function Handler(config = {}) {
    return (target, methodName, descriptor) => {
        if (!target.constructor[config_1.FUNCTIONS_METADATA]) {
            target.constructor[config_1.FUNCTIONS_METADATA] = {};
        }
        target.constructor[config_1.FUNCTIONS_METADATA][methodName] = config;
        const localInvoke = descriptor.value;
        function awsInvoke(...args) {
            return __awaiter(this, void 0, void 0, function* () {
                if (process.env.IS_LOCAL === 'true') {
                    const ServiceClass = target.constructor;
                    return localInvoke.apply(new ServiceClass(), args);
                }
                const functionName = config.name || `${process.env.SLS_DECORATORS_FUNC_PREFIX}-${methodName}`;
                console.log(`Invoking Lambda function: ${functionName}`);
                const lambda = new aws_sdk_1.Lambda();
                return new Promise((resolve, reject) => {
                    lambda.invoke({
                        FunctionName: functionName,
                        InvocationType: 'Event',
                        Payload: JSON.stringify(args[0]),
                    }, (err, data) => (err ? reject(err) : resolve(data)));
                });
            });
        }
        target[`__invoke_${methodName}`] = localInvoke;
        descriptor.value = awsInvoke;
        return descriptor;
    };
}
exports.Handler = Handler;
